#!/usr/bin/perl
#
#   

use strict;
use lib '/home/ehud/www';
use NDBM_File;
use Fcntl;
use File::BasicFlock;

my $base_dir = '/home/ehud/www';
my $TITLE = ' ';
my $PAGE = 10; #     
my $now = time(); #  

my %FORM;

&ParseForm();

my $arg = $ENV{'PATH_INFO'};

if ($arg =~ m@^/post@) {
  &Post();
}
else {
  if ($arg =~ m@^/([0-9]+)@) {
    &DisplayIt($1);
  }
  else {
    &DisplayIt(0);
  }
}

### END OF MAIN ###

sub PollNum {
  my ($i);

  $i = 0;
  while (-f "$base_dir/misc/poll$i.conf") {
    $i += 1;
  }

  return POSIX::floor(rand() * $i);
}

sub CutMozilla4 {
  my ($template) = @_;

  if ($ENV{'HTTP_USER_AGENT'} =~ m@Mozilla/4@ &&
      $ENV{'HTTP_USER_AGENT'} !~ m@X11@) {
    $template =~ s@<!--Mozilla_4.x_only-->([\x00-\xff]*?)<!--/Mozilla_4.x_only-->@$1@g;
  }
  else {
    $template =~ s@<!--Mozilla_4.x_only-->[\x00-\xff]*?<!--/Mozilla_4.x_only-->@@g;
  }

  return $template;
}

sub PollQ {
  my ($id) = @_;
  my $q;

  open(FILE, "<$base_dir/misc/poll$id.conf");
  while (<FILE>) {
    if (m@question\{([^\}]*)\}@) {
      $q = $1;
    }
  }
  close(FILE);

  return $q;
}

sub DisplayIt {
  my ($page) = @_;
  my ($template, $slogan, $form, $gb);

  open(FILE, "<$base_dir/template/razdel.html");
  while (<FILE>) {
    $template .= $_;
  }
  close(FILE);

  $slogan = &SloganNum();
  $template =~ s@<!--slogan-->@/image/slogan/slogan$slogan.gif@g;

  $slogan = &PollNum();
  $template =~ s@<!--poll_id-->@$slogan@g;
  $slogan = &PollQ($slogan);
  $template =~ s@<!--poll_q-->@$slogan@g;

  $template =~ s@<!--main_only-->[\x00-\xff]*?<!--/main_only-->@@g;
  $template =~ s@<!--rambler-->[\x00-\xff]*?<!--/rambler-->@@g;

  $template = &CutMozilla4($template);
  $template =~ s@<!--\#echo var=\'DOCUMENT_URI\'-->@$ENV{'PATH_INFO'}@g;

  $template =~ s/<!--title-->/$TITLE/g;
  $template =~ s/<!--current_razdel-->/gb/g;
  $template =~ s@<!--bibigame-->@@g;
  $form = &Form();
  $template =~ s@<!--comment-->[\x00-\xff]*?<!--/comment-->@$form@g;
  $template =~ s@<!--news-->[\x00-\xff]*?<!--/news-->@@g;
  $gb = &Gb($page);
  $template =~ s@<!--textuxa-->[\x00-\xff]*?<!--/textuxa-->@$gb@g;
  $template =~ s@<!--doc_anons-->[\x00-\xff]*?<!--/doc_anons-->@@g;

  &StartHTML();
  print $template;
}

sub Form {
  return <<STUFF;
<table border="0">
<form action="/misc/gb.cgi/post" method="POST">
<tr><td>:</td><td><input type="text" name="name" size="20"></td></tr>
<tr><td>Email:</td><td><input type="text" name="email" size="20"></td></tr>
<tr><td> :</td><td><input type="text" name="url" value="http://" size="20"></td></tr>
<tr><td> :</td><td><input type="text" name="url_name" size="20"></td></tr>
<tr><td>:</td><td><input type="text" name="city" size="20"></td></tr>
<tr><td>:</td><td><input type="text" name="country" size="20"></td></tr>
<!-- <tr><td>  \#:</td><td><input type="text" name="re" size="20"></td></tr> -->
<tr><td colspan="2">:<br><textarea name="text" cols="30" rows="10" wrap="virtual"></textarea></td></tr>
<tr><td colspan="2"><center><input type="submit" value=""></center></td></tr>
</form>
</table>
STUFF
}

sub Gb {
  my ($page) = @_;
  my ($gb, %HASH, $i, @chunks);
  my ($name, $email, $url, $url_name, $city, $country, $re, $text);
  my ($header, $rustime, $count);

  lock("$base_dir/misc/gb.db", 'shared');
  tie(%HASH, 'NDBM_File', 'gb', O_RDONLY, 0644);

  $count = -1;
  foreach $i (reverse sort keys %HASH) {
    if ($i =~ /^[0-9]+$/) {
      $count++;

      if (int($count / $PAGE) == $page) {
	($name, $email, $url, $url_name, $city,
	 $country, $re, @chunks) = split(/\n/, $HASH{$i});
	$text = join("<br>\n", @chunks);

	$rustime = &RusTime($i);
	$header = "<small><b>$rustime</b></small><br>\n";
	$header .= ($email =~ /\@/) ? "<a href=\"mailto:$email\">$name</a>" :
	  "<u>$name</u>";
	$header .= " &nbsp; <i> $city $country</i><br>";

	if ($url =~ m@^http://.+@) {
	  $header .= ($url_name ne '') ?
	    "<i><a href=\"$url\">$url_name</a></i>" :
	      "<i><a href=\"$url\">$url</a></i>";
	  $header .= "<br>\n";
	}

	$gb .= <<STUFF;
<hr size="0" noshade>
$header<br>
$text
STUFF
      }
    }
  }

  $gb .= "<hr size=\"0\" noshade>\n<center>";

  foreach $i (0..int($count / $PAGE)) {
    if ($i == $page) {
      $gb .= "$i&nbsp;";
    }
    else {
      $gb .= "<a href=\"/misc/gb.cgi/$i\">$i</a>&nbsp;";
    }
  }

  $gb .= "</center>\n";

  untie(%HASH);
  unlock("$base_dir/misc/gb.db");

  return $gb
}

sub Post {
  my (%HASH);

  lock("$base_dir/misc/gb.db");
  tie(%HASH, 'NDBM_File', 'gb', O_RDWR, 0644);
  $HASH{$now} = "$FORM{'name'}\n$FORM{'email'}\n$FORM{'url'}\n$FORM{'url_name'}\n$FORM{'city'}\n$FORM{'country'}\n$FORM{'re'}\n$FORM{'text'}\n";
  untie(%HASH);
  unlock("$base_dir/misc/gb.db");

  print "Location: http:/misc/gb.cgi\n\n";
}

sub SloganNum {
  my ($i);

  $i = 0;
  while (-f "$base_dir/image/slogan/slogan$i.gif") {
    $i += 1;
  }

  return POSIX::floor(rand() * $i);
}

sub StartHTML {
  print "Content-type: text/html; charset=koi8-r\n\n";
}

sub ParseForm {
  my (@pairs, $buffer, $name, $value, $pair);

  if ($ENV{'REQUEST_METHOD'} eq 'GET') {
    @pairs = split(/&/, $ENV{'QUERY_STRING'});
  }
  else {
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
    @pairs = split(/&/, $buffer);
  }

  foreach $pair (@pairs) {
    ($name, $value) = split(/=/, $pair);

    # Un-Webify plus signs and %-encoding
    $value =~ tr/+/ /;
    $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
    $value =~ s/<!--(.|\n)*-->//g; #  HTML-

    # Strip HTML
    $value =~ s/<([^>]|\n)*>//g;

    $FORM{$name} = $value;
  }
  return 1;
}

sub RusTime {
  my ($time) = @_;
  my ($hh, $mm, $dd, $month, $yy, @date);

  $time += (7 * 3600); #  

  @date = localtime($time);
  $hh = $date[2];
  $mm = $date[1];
  $dd = $date[3];
  #$month = $rusmonth[$date[4]];
  $month = $date[4] + 1;
  #$yy = $date[5] + 1900;
  $yy = $date[5] % 100;
  $yy = "0$yy" if ($yy < 10);
  $hh = "0$hh" if ($hh < 10);
  $mm = "0$mm" if ($mm < 10);
  $month = "0$month" if ($month < 10);
  $dd = "0$dd" if ($dd < 10);
  return("$dd.$month.$yy, $hh:$mm");
}
